#ifndef _GF256_h
#define _GF256_h

class GF256 {
public:
  GF256(int val=0);

  GF256& operator=(const GF256& b) {
    polynomial = b.polynomial;
    return *this;
  }

  GF256 operator+=(const GF256& b) {
    *this = *this + b;
    return *this;
  }

  GF256 operator-=(const GF256& b) {
    *this = *this - b;
    return *this;
  }

  GF256 operator*=(const GF256& b) {
    *this = *this * b;
    return *this;
  }

  GF256 operator/=(const GF256& b) {
    *this = *this / b;
    return *this;
  }

  GF256 operator+(const GF256& b) const;
  GF256 operator-(const GF256& b) const;
  GF256 operator*(const GF256& b) const;
  GF256 operator/(const GF256& b) const;

  GF256 operator-() const;

  int pow() const;

  operator int() const { 
    return polynomial;
  }

private:
  int polynomial;
};

#endif // _GF256_h
